<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Bootstrap Grid System</title>

		<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>

	<h1 class="text-center">Bootstrap Grid System</h1>

	<!-- Two column layout -->
<!-- 	<h2 class="text-center">Two Column Layout</h2>
	<div class="container">
		<h3 class="text-center bg-dark">1:1 Ratio</h3>
		<div class="row text-white text-center">
			<div class="bg-primary p-3 border border-dark col-6">6 Colums</div>
			<div class="bg-danger p-3 border border-dark col-6"></div>
		</div>
	</div> -->

	<div class="container-fluid bg-secondary mt-3">
		<h3 class="text-center">1:1 Ratio</h3>
		<div class="row text-white text-center">
			<div class="bg-primary p-3 border border-dark col-6">6 Columns</div>
			
			<div class="bg-danger p-3 border border-dark col-6">6 Columns</div>
		</div>
		<h3 class="text-center">1:2 RAtio</h3>
		<div class="row text-center mt-3">
			<div class="bg-innfo border border-dark col-4 p-3">4 Column</div>
			
			<div class="bg-warning border border-dark col-8" p-3>8 column</div>
			
			<!-- if the number of columns in a row exceeds 12, the next div will overflow to the nex line. -->
			<div class="bg-success border border-dark col-3 p-3">3 Column</div>
		</div>
	</div>

	<!-- 
		Bootsrap grid system runs on a rule of CRC 

			Container - sets the max wiidth of our grid system
			row - holds 12 columns each row is divided in equaly 12
			column - is where ouur content will be added


	-->

	<!-- Three Columns -->
	<h2 class="text-center my-5">Three Column Layout</h2>
	<div class="container-fluid bg-secondary">
		<h3 class="text-center">1:1:1</h3>
		<div class="row text-center">
			<div class="col-4 bg-info border border-dark p-3">4 Column</div>
			<div class="col-4 bg-warning border border-dark p-3">4 Column</div>
			<div class="col-4 bg-success border border-dark p-3">4 Column</div>
		</div>
		<h3 class="text-center">Uneven Columns</h3>
		<div class="row text-center">
			<div class="col-5 bg-primary border border-dark p-3">5 col</div>
			<div class="col-4 bg-danger border border-dark p-3">4 col</div>
			<div class="col-3 bg-success border border-dark p-3">3 col</div>
		</div>
	</div>

	<!-- Column with content -->
	<h2 class="text-center my-5">Column with Sample Content</h2>
	<div class="container-fluid bg-dark">
		<div class="row">
			<div class="col-6 p-3 text-white">
				<h3>Sample Comntent</h3>
				<p>
					Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
					tempor incididunt ut labore et dolore magna aliqua.
				</p>
			</div>
			<div class="col-6 p-3">
				<img src="https://place-puppy.com/1000x1000" class="img-fluid">
			</div>
		</div>
	</div>

	<!-- Activity -->
	<h3 class="text-center my-5">Mini Activity with 3 COlumns</h3>
	<div class="container-fluid">
		<div class="row">
			<div class="col-5">
				<h3>This text's column is bigger than the picture</h3>
			</div>
			<div class="col-2">
				<img src="https://placebear.com/500/500" class="img-fluid">
			</div>
			<div class="col-5">
				<p>This text's column is bigger than the picture</p>
			</div>
		</div>
	</div>

	<!-- Auto Columns -->
	<h2 class="my-5 text-center">Auto Columns</h2>
	<!-- to add a number of columns in a row can occuupy the syntax of the bootsrap class is this: col-<#Col>-->

	<div class="container-fluid bg-secondary">
		<div class="row">
			<!-- when creating a column but not proviiding the total numberof grid columns to occupy, bootsrap will then assiign and calculate the total number of columns left in the row and assiign it per auto column accordingly -->
			<div class="bg-danger border border-dark p-3 col">Auto 1</div>
			<div class="bg-success border border-dark p-3 col">Auto 2</div>
			<div class="bg-info border border-dark p-3 col">Auto 3</div>
			<div class="bg-success border border-dark p-3 col">Auto 4</div>
			<div class="bg-light border border-dark p-3 col">Auto 5</div>
			<div class="bg-secondary border border-dark p-3 col">Auto 6</div>
			<div class="bg-primary border border-dark p-3 col">Auto 7</div>
		</div>

		<div class="row my-5">
			<div class="col-6 bg-primary border border-dark">
				Col 6
			</div>
			<div class="col bg-success border border-dark">Auto</div>
			<div class="col bg-info border border-dark">Auto</div>
			<div class="col bg bg-danger border border-dark">Auto</div>
		</div>
	</div>

	<!-- Breakpoints and columns -->
	<h2 class="my-5 text-center">Breakpoints and Columns</h2>
	<div class="container-fluid bg-dark">
		<div class="row">
			<!-- by default, a column will occupy 12 columns, until its breakpoint. A breakkepoint is the screen or screen size where in the numer of columns given will take effect -->
			<div class="col-lg-6 bg-danger border border-dark p-3">
				6 Cols in lg, 12 Cols in xs
			</div>

			<!-- by declaring or adding col without breakepoint this means that div has 6 columns from the smallest screen to the largest -->
			<div class="col-lg-6 bg-primary border border-dark p-3">
				6 Cols all screen
			</div>
		</div>
		<div class="row my-5">
			<!-- column without  breakpoint means the nnumber of colims from the smallest screen unntil the breakpoint. from the breakpoint, lg, this div iis noow 8 columns -->
			<div class="col-3 col-lg-8 bg-info border border-dark p-3">
				col-lg-8
			</div>

			<!-- Without settin the number of columns from the smallest screen, by default, the column will occupy 12 columns until breakkepoint -->
			<div class="col-md-4 bg-warning border border-dark p-3">
				col-md-4
			</div>
		</div>
		

		<!-- 
			Breakpoints

		You can set the numbers of a div occupies per screen using breakpoint. Howevere, by default fromm the smallest screen a div with class col will occupy 12 columns.

		This because, bootsrap is a mobile-first approach to styling a web page.

		Meaning utli you add a breakpoint (sm, md, lg, xl) the number of columns a div will occupy will be the same from the smallest to the largest screen.	


		 columns can be sized with breakpoints starting from the smallest:

			col-*  - from the smallest. 
			
			(Cellphones)
			col-sm* - breakepoint friom small screen or about 576 screen width.
			
			(Tablets)
			col-md-*	 - breakpoint from the medium screen or tablet or 768px screen width.
			
			(Laptop)
			col-lg-* - breakepoint from the large screen or laptop or 992 screen width.
			
			(Larger Screen)
			col-xl-* - breakepoint from the largest screen or 1200px screen width


			If a div in a row has the following classes:
			col-6 col-md-10

			How many columns does the div occupy in the smallest screen? 6
			How many columns does the div occupy in the medium screen? 10
			How many columns does the div occupy in the largest screen? 10

			col-sm-10
			How many columns does the div occupy in the smallest screen? 12
			How many columns does the div occupy in the small screen? 10
			How many columns does the div occupy in the medium screen? 10
			How many columns does the div occupy in the largest screen? 10

			col-12
			How many columns does the div occupy in the smallest screen? 12
			How many columns does the div occupy in the small screen? 12
			How many columns does the div occupy in the medium screen? 12
			How many columns does the div occupy in the largest screen? 12

			col-3 col-lg-6
			How many columns does the div occupy in the smallest screen? 3
			How many columns does the div occupy in the small screen? 3
			How many columns does the div occupy in the medium screen? 3
			How many columns does the div occupy in the largest screen? 6

			col-md-8
			How many columns does the div occupy in the smallest screen? 12
			How many columns does the div occupy in the small screen? 12
			How many columns does the div occupy in the medium screen? 8
			How many columns does the div occupy in the largest screen? 8

		-->
			<!-- Mini Activity -->
				<h3 class="text-center my-5">Mini Activity with Breakpoints</h3>
				<div class="row mb-5">
					<div class="col-6 bg-primary border border-dark p-3">
						Div 1
					</div>
					<div class="col-6 col-md-10 bg-danger border border-dark p-3">
						Div 2
					</div>

				</div>	
					<div class="row">
						<div class="col-md-8 bg-success border border-dark p-3 ">
							Div 1
						</div>
						<div class="col-6 col-md-2 bg-info border border-dark p-3">
							Div 2
						</div>
						<div class="col-6 col-md-2 bg-info border border-dark p-3">
							Div 3
						</div>
					</div>

					<!-- Breakpoint with text alignment -->
					<!-- Default alignment: Left alignment -->

					<h3 class="text-md-center my-5">Text ALignment with Breakpoints</h3>
					<div class="row">
						<div class="col-6 col-md-8 text-right text-md-left bg-primary border border-dark p-3">
							Div 1
						</div>
						<div class="col-6 col-md-4 text-md-right bg-danger border border-dark p-3">
							Div 2
						</div>
					</div>

					<h2 class="text-center my-5">Display Order with Breakpoints</h2>
					<div class="row">
						<div class="col-6 col-md-10 order-2 order-md-1 bg-warning border border-dark p-3">
							Div 1
						</div>	
						<div class="col-6 col-md-2 order-1 order-md-2 bg-primary border border-dark p-3">
							Div 2
						</div>	
						
					</div>

					<h3 class="text-md-center my-5">Mini Activity with Order</h3>
					<div class="row">
						<div class="col-4 bg-warning border border-dark p-3 order-1 order-md-2 order-lg-3">
							Lebron
						</div>	
						<div class="col-4 bg-primary border border-dark p-3 order-3 order-md-1 order-lg-2">
							Curry
						</div>	
						<div class="col-4 bg-secondary border border-dark p-3 text-white order-2 order-md-3 order-lg-1">
							Durant
						</div>				
					</div>
	</div>



	<!-- JS Dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>